<?php
    /**
     * The plugin bootstrap file
     *
     * This file is read by WordPress to generate the plugin information in the
     * plugin admin area. This file also defines a function that starts the plugin.
     *
     * @link              http://54online.com/
     * @since             1.0.5
     * @package           pechka54
     *
     * @wordpress-plugin
     * Plugin Name:       pechka54
     * Plugin URI:        http://54online.com/
     * Description:       http://54online.com/
     * Version:           1.0.6
     * Author:            http://54online.com/
     * Author URI:        http://54online.com/
     * License:           GPL-2.0+
     * License URI:       http://www.gnu.org/licenses/gpl-2.0.txt
     */

// If this file is called directly, abort.
    if (!defined('WPINC')) {
        die;
    }

// Include the dependencies needed to instantiate the plugin.
    foreach (glob(plugin_dir_path(__FILE__) . 'admin/*.php') as $file) {
        include_once $file;
    }

    global $pechka_db_version;
    $pechka_db_version = '1.0';

    /* INSTALL */

    register_activation_hook(__FILE__, 'pechka_install');
    function pechka_install()
    {
        global $wpdb;
        global $jal_db_version;
        /*список ккм*/
        $table_name = $wpdb->prefix . 'pechka_kkm_table';

        $charset_collate = $wpdb->get_charset_collate();

        $sql = "CREATE TABLE $table_name (
		id mediumint(9) NOT NULL AUTO_INCREMENT,
		time datetime DEFAULT '0000-00-00 00:00:00' NOT NULL,
		lasttime datetime DEFAULT '0000-00-00 00:00:00' NOT NULL,
		name text NOT NULL,
		serial text NOT NULL,
		inn text NOT NULL,
		action text NOT NULL,
		sendmail text NOT NULL,
		adressmail text NOT NULL,
		paymethod text NOT NULL,
		PRIMARY KEY  (id)
	) $charset_collate;";

        require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
        dbDelta($sql);
        /*список заказов*/
        $table_name = $wpdb->prefix . 'pechka_kkm_order';

        $charset_collate = $wpdb->get_charset_collate();

        $sql = "CREATE TABLE $table_name (
		id mediumint(9) NOT NULL AUTO_INCREMENT,
		time datetime DEFAULT '0000-00-00 00:00:00' NOT NULL,
		lasttime datetime DEFAULT '0000-00-00 00:00:00' NOT NULL,
		orderid text NOT NULL,
		kkm text NOT NULL,
		inn text NOT NULL,
		fn text NOT NULL,
		shiftnumber text NOT NULL,
		resultcode text NOT NULL,
		resultinfo text NOT NULL,
		OFDLink text NOT NULL,
		PRIMARY KEY  (id)
	) $charset_collate;";

        require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
        dbDelta($sql);
        /*налоги*/
        $table_name = $wpdb->prefix . 'pechka_kkm_tax';

        $charset_collate = $wpdb->get_charset_collate();

        $sql = "CREATE TABLE $table_name (
		id mediumint(9) NOT NULL AUTO_INCREMENT,
		kkmtax text NOT NULL,
		kkmtaxrate INT(2),
		cmstaxid text DEFAULT NULL,
		PRIMARY KEY  (id)
	) $charset_collate;";

        require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
        dbDelta($sql);

        add_option('jal_db_version', $pechka_db_version); // jal оставлено для совместимости со старым кодом
    }

    register_activation_hook(__FILE__, 'pechka_install_demo');
    function pechka_install_demo()
    {
        global $wpdb;
        /*демо список ккм*/
        $kkm_name = 'Demo KKM';
        $kkm_serial = '0000123111456';
        $kkm_inn = '78012345678';

        $table_name = $wpdb->prefix . 'pechka_kkm_table';

        $wpdb->insert(
            $table_name,
            array(
                'time' => current_time('mysql'),
                'name' => $kkm_name,
                'serial' => $kkm_serial,
                'inn' => $kkm_inn,
            )
        );
    }

    /* UNINSTAL */

    register_deactivation_hook(__FILE__, 'pechka_uninstall');
    register_uninstall_hook(__FILE__, 'pechka_uninstall');
    function pechka_uninstall()
    {
        global $wpdb;

        /*список ккм*/
        $table_name = $wpdb->prefix . 'pechka_kkm_table';
        $wpdb->query("DROP TABLE IF EXISTS $table_name");

        /*список заказов*/
        $table_name = $wpdb->prefix . 'pechka_kkm_order';
        $wpdb->query("DROP TABLE IF EXISTS $table_name");

        /*налоги*/
        $table_name = $wpdb->prefix . 'pechka_kkm_tax';
        $wpdb->query("DROP TABLE IF EXISTS $table_name");

        delete_option('jal_db_version');
    }

    /* ADMIN SETTINGS */

    add_action('plugins_loaded', 'pechka_admin_settings');
    function pechka_admin_settings()
    {
        $serializer = new Serializer();
        $serializer->init();

        $plugin = new Submenu(new Submenu_Page());
        $plugin->init();
    }

    /* EVENTS */

// Синхронизация ККМ
    add_action('admin_post_nopriv_sync', 'sync');
    add_action('admin_post_sync', 'sync');
    function sync()
    {
        global $wpdb;
        $kkm_table = $wpdb->prefix . 'pechka_kkm_table';
        $taxes_table = $wpdb->prefix . 'pechka_kkm_tax';
        $data = array(
            'name' => htmlspecialchars($_POST['data']['0']['name']),
            'serial' => htmlspecialchars($_POST['data']['0']['kkm']),
            'inn' => htmlspecialchars($_POST['data']['0']['inn']),
            'taxes' => $_POST['data']['0']['taxes']
        );

        $id = lastRowId();
        if ($id) {
            $res = $wpdb->update(
                $kkm_table,
                array(
                    'lasttime' => current_time('mysql'),
                    'name' => $data['name'],
                    'serial' => $data['serial'],
                    'inn' => $data['inn']
                ),
                array('ID' => $id)
            );
            if (!$res) {
                debug("Ошибка обновления записи кассы\r\n" . var_export($data, true));
                sendResponse(1, "Ошибка обновления записи кассы");
            }

        } else {
            $res = $wpdb->insert(
                $kkm_table,
                array(
                    'lasttime' => current_time('mysql'),
                    'name' => $data['name'],
                    'serial' => $data['serial'],
                    'inn' => $data['inn']
                )
            );
            if (!$res) {
                debug("Ошибка добавления записи кассы\r\n" . var_export($data, true));
                sendResponse(1, "Ошибка добавления записи кассы");
            }
        }
        if ($res) {
            debug("Синхронизирован список касс");
            sendResponse(0, "Синхронизирован список касс");
        }

        foreach ($data['taxes'] as $tax) {
            $tax_id = getTaxId($tax['id']);
            if ($tax_id) {
                $taxe_update_result = $wpdb->update(
                    $taxes_table,
                    array(
                        'kkmtax' => $tax['title']
                    ),
                    array('id' => $tax_id)
                );
                debug($tax['title'] . '-' . $tax['id'] . '-' . 'обновлен');
            }

            if (!$taxe_update_result) {
                debug("Ошибка обновления записи налогов\r\n" . var_export($data['taxes'], true));
                sendResponse(1, "Ошибка обновления записи налога");
            }

            if (!$tax_id) {
                $taxe_insert_result = $wpdb->insert(
                    $taxes_table,
                    array(
                        'id' => $tax['id'],
                        'kkmtax' => $tax['title']
                    )
                );
            }

            if (!$taxe_insert_result) {
                debug("Ошибка добавления записи налогов\r\n" . var_export($data['taxes'], true));
                sendResponse(1, "Ошибка добавления записи налога");
            }
        }
    }

// Если ККМ активна
    add_action('admin_post_nopriv_KKMConnected', 'KKMConnected');
    add_action('admin_post_KKMConnected', 'KKMConnected');
    function KKMConnected()
    {
        /*статус активности*/
        $status = 'Y';
        /*записываю статус активности ккм*/
        global $wpdb;
        $table_name = $wpdb->prefix . 'pechka_kkm_table';
        $wpdb->update(
            $table_name,
            array('lasttime' => current_time('mysql'), 'action' => $status),
            array('ID' => lastRowId())
        );
        /*запрашиваю статус перед отправкой письма*/
        $mails = $wpdb->get_row("SELECT * FROM {$table_name}");
        $mailsend = json_decode(json_encode($mails), true);
        $mailstatus = $mailsend['sendmail'];
        $mailadress = $mailsend['adressmail'];
        $mailname = $mailsend['name'];
        $mailserial = $mailsend['serial'];
        /*если письмо о неактивности (send) было отправлено*/
        if ($mailstatus == 'send') {
            /*перед отправкой ставлю сбрасываю статус отправки письма*/
            $sendmail = '';
            $wpdb->update(
                $table_name,
                array('sendmail' => $sendmail),
                array('ID' => lastRowId())
            );
            /*отправляю письмо*/
            $to = $mailadress;
            $subject = 'ККМ сайта ' . site_url() . ' активна';
            $body = 'ККМ ' . $mailname . ', ' . $mailserial . ' активна';
            wp_mail($to, $subject, $body);
        }
    }

// Если ККМ не активна
    add_action('admin_post_nopriv_KKMDisconnected', 'KKMDisconnected');
    add_action('admin_post_KKMDisconnected', 'KKMDisconnected');
    function KKMDisconnected()
    {
        /*статус активности*/
        $status = 'N';
        /*записываю статус активности ккм*/
        global $wpdb;
        $table_name = $wpdb->prefix . 'pechka_kkm_table';
        $wpdb->update(
            $table_name,
            array('time' => current_time('mysql'), 'action' => $status),
            array('ID' => lastRowId())
        );
        /*запрашиваю статус перед отправкой письма*/
        $mails = $wpdb->get_row("SELECT * FROM {$table_name}");
        $mailsend = json_decode(json_encode($mails), true);
        $mailstatus = $mailsend['sendmail'];
        $mailadress = $mailsend['adressmail'];
        $mailname = $mailsend['name'];
        $mailserial = $mailsend['serial'];
        /*если send, письмо отправлено, ничего не делаем*/
        if ($mailstatus != 'send') {
            /*перед отправкой ставлю статус отправлено*/
            $sendmail = 'send';
            $wpdb->update(
                $table_name,
                array('sendmail' => $sendmail),
                array('ID' => lastRowId())
            );
            /*отправляю письмо*/
            $to = $mailadress;
            $subject = 'ККМ сайта ' . site_url() . ' не активна';
            $body = 'ККМ ' . $mailname . ', ' . $mailserial . ' не активна';
            wp_mail($to, $subject, $body);
        }
    }

// Оплата заказа
// add_action('woocommerce_payment_complete', 'so_payment_complete');
    add_action('woocommerce_order_status_processing', 'so_payment_complete');
    function so_payment_complete($order_id)
    {
        global $woocommerce, $wpdb;

        $order = new WC_Order($order_id);
        $order_data = $order->get_data();
        // тип оплаты заказа
        $order_paym = $order_data['payment_method'];
        // получаю список разрешенных методов оплаты
        $table_name = $wpdb->get_blog_prefix() . 'pechka_kkm_table';
        $payms = $wpdb->get_row("SELECT * FROM {$table_name}");
        $paym = json_decode(json_encode($payms), true);
        // список разрешенных методов оплаты в виде массива
        $paymKkm = explode(",", $paym['paymethod']);
        // если метод оплаты заказа есть в списке разрешенных методов оплаты в таблице БД, записываю заказ
        if (in_array($order_paym, $paymKkm, true) == true) {
            // записываю заказ в таблицу заказов печки
            $table_name = $wpdb->prefix . 'pechka_kkm_order';
            $res = $wpdb->insert(
                $table_name,
                array(
                    'id' => $order_id,
                    'time' => current_time('mysql'),
                    'resultcode' => '-1', // заказ еще не распечатан
                )
            );
            if ($res) {
                debug("Заказ $order_id добавлен в таблицу печати чеков");
            } else {
                debug("Заказ $order_id не добавлен в таблицу печати чеков (неправильные входные параметры или заказ уже добавлен)");
            }
        } else {
            debug("Способ оплаты заказа $order_id не входит в выбранные способы оплаты в плагине");
        }
    }

// Получение информации об оплаченных заказах
    add_action('admin_post_nopriv_order', 'order');
    add_action('admin_post_order', 'order');
    function order()
    {
        /*серийник ККМ из запроса*/
        $serial = $_POST['kkm'];
        /*серийник ККМ из бд*/
        global $wpdb;
        $table_name = $wpdb->get_blog_prefix() . 'pechka_kkm_table';
        $kkm = $wpdb->get_row("SELECT * FROM {$table_name}");
        $kkma = json_decode(json_encode($kkm), true);
        $kkmSerial = $kkma['serial'];
        /*если серийник из запроса и серийник из ДБ совпали*/
        if ($serial == $kkmSerial) {
            /*запрос ID заказа на печать с resultcode = -1*/
            $table_print = $wpdb->get_blog_prefix() . 'pechka_kkm_order';
            $printOrders = $wpdb->get_row("SELECT ID FROM {$table_print} WHERE resultcode in (-1)");
            $printOrder = json_decode(json_encode($printOrders), true);
            $printOrderId = $printOrder['ID'];
            /*запрос тела заказа из woocommerce по ID*/
            if (!empty($printOrderId)) {
                $order = wc_get_order($printOrderId);
                $data = $order->get_data();
                /*стоимость доставки*/
                $data_shipping_total = $data['shipping_total'];
                $order_items = $order->get_items();
                if (!empty($data['billing']['phone'])) {
                    $contactInfo = $data['billing']['phone'];
                } else {
                    $contactInfo = $data['billing']['email'];
                }
                echo '{
			  "resultCode":0,
			  "resultInfo":"заказ № ' . $printOrderId . ' печать чека",
			  "response": {
				"kkm": "' . $kkmSerial . '",
				"OrderId": "' . $data['id'] . '",
				"taskTable": [
				  {
					"data": "",
					"type": "OpenCheckSell"
				  },
				  {
					"data": "' . $contactInfo . '",
					"type": "ClientContact"
				  },';
                /*весь массив товара*/
                foreach ($order_items as $item_id => $item) {
                    $item_data = $item->get_data();
                    $item_price = $item_data['total'] / $item_data['quantity'];

                    /*Если налоги в woocommerce включены*/
                    if (wc_tax_enabled()) {
                        $item_price += (getCurrentTaxRate($item_data['tax_class'])/100 * $item_price);
                    }

                    echo '{
					"data": "' . $item_data['name'] . '",
					"param": {
					  "price": "' . round($item_price,2) . '",
					  "quantity": "' . $item_data['quantity'] . '",
					  "tax": "' . getCurrentTaxId($item_data['tax_class']) . '"
					},
					"type": "registration"
				  },';
                }
                /*товар доставка*/
                if (!$data_shipping_total == null) {
                    /*получаем ндс доставки*/
                    $WC_Order_Item_Shipping = new WC_Order_Item_Shipping();
                    $shipping_tax_class = $WC_Order_Item_Shipping-> get_tax_class();
                    $shipping_price = $data_shipping_total;

                    if (wc_tax_enabled()) {
                        $shipping_price += (getCurrentTaxRate($shipping_tax_class)/100 * $data_shipping_total);
                    }
                    echo '
				{
				  "data": "Доставка",
				  "param": {
				  "price": "' . round($shipping_price,2) . '",
				  "quantity": "1",
				  "tax":"' . getCurrentTaxId($shipping_tax_class) .'"
				  },
				"type": "registration"
				},
			';
                }
                echo '{
				"data": "",
				"Param": {
				  "Summ": "' . $data['total'] . '",
				  "TypeClose": 1
				},
				"type": "Payment"
			  },
				  {
					"data": "",
					"type": "CloseCheck"
				  }
				]
			  }
			}';
            } else {
                echo '{"resultCode":0,"resultInfo":"нет чеков для печати"}';
            }
        } else {
            echo '{"resultCode":1,"resultInfo":"ошибка"}';
        }
    }

// Подтверждение печати чека
    add_action('admin_post_nopriv_orderConfirm', 'orderConfirm');
    add_action('admin_post_orderConfirm', 'orderConfirm');
    function orderConfirm()
    {
        $id = $_POST['orderId'];
        $orderid = $_POST['orderId'];
        $kkm = $_POST['kkm'];
        $inn = $_POST['inn'];
        $fn = $_POST['fn'];
        $shiftnumber = $_POST['shiftNumber'];
        $resultcode = $_POST['resultCode'];
        $resultinfo = $_POST['resultInfo'];
        $ofdlink = $_POST['OFDLink'];

        global $wpdb;
        $table_name = $wpdb->prefix . 'pechka_kkm_order';
        $wpdb->update(
            $table_name,
            array(
                'id' => $orderid,
                'lasttime' => current_time('mysql'),
                'orderid' => $orderid,
                'kkm' => $kkm,
                'inn' => $inn,
                'fn' => $fn,
                'shiftnumber' => $shiftnumber,
                'resultcode' => $resultcode,
                'resultinfo' => $resultinfo,
                'OFDLink' => $ofdlink,
            ),
            array('ID' => $orderid)
        );
        /* Отправка чека клиенту */
        if( strlen( $ofdlink )>0 )
        {
            if (!empty($orderid))
            {
                $order = wc_get_order($orderid);
                $data = $order->get_data();
                if (!empty($data['billing']['email']))
                {
                    $to = $data['billing']['email'];
                }
            }
            if( strpos( $to, '@' ) !== false )
            {
                $mails = $wpdb->get_row("SELECT * FROM {$table_name}");
                $mailsend = json_decode(json_encode($mails), true);
                $from = $mailsend['adressmail'];
                $subject = 'Ваш чек с сайта ' . site_url();
                $body = 'Ваш чек оплаты ' . $ofdlink . ' с сайта ' . site_url();
                wp_mail( $to, $subject, $body );
            }
        }
    }

    /* FUNCTIONS */

// id последней строки из талицы касс
    function lastRowId()
    {
        global $wpdb;
        $table_name = $wpdb->get_blog_prefix() . 'pechka_kkm_table';
        $kkm = $wpdb->get_row("SELECT * FROM {$table_name} ORDER BY id DESC LIMIT 1");
        $kkm = json_decode(json_encode($kkm), true);
        return ($kkm['id']) ?: false;
    }

// искомый id из талицы налогов
    function getTaxId($id)
    {
        global $wpdb;
        $table_name = $wpdb->get_blog_prefix() . 'pechka_kkm_tax';
        $tax_id = $wpdb->get_row( "SELECT * FROM {$table_name} WHERE id = $id");
        $tax_id = json_decode(json_encode($tax_id), true);

        return ($tax_id['id']) ?: false;
    }

// json ответ печке
    function sendResponse($code, $text)
    {
        echo '{"resultCode":' . $code . ',"resultInfo":"' . $text . '"}';
    }

    /* debug */
    function debug($var)
    {
        if (true) {
            file_put_contents(
                __DIR__ . '/logs.log',
                date('Y-m-d') . ' ' . date('H:m') . ': ' . $var . "\r\n",
                FILE_APPEND
            );
        }
    }

    /*Получаем ставку налога из woocommerce*/
    function getCurrentTaxRate($cms_tax_class)
    {
        global $wpdb;
        $cms_tax_id = $wpdb->get_row($wpdb->prepare("SELECT * FROM `{$wpdb->prefix}woocommerce_tax_rates` WHERE `tax_rate_class` = %s;", sanitize_title($cms_tax_class)));
        $cms_tax_id = json_decode(json_encode($cms_tax_id), true);

        $current_tax_rate = $cms_tax_id["tax_rate"];

        return $current_tax_rate;
    }

    /*Ищем соответствие налоговой ставки для woocommerce в таблице ставок выгруженных из кассы*/
    function getCurrentTaxId($cms_tax_class)
    {
        global $wpdb;
        $cms_tax_id = $wpdb->get_row($wpdb->prepare("SELECT * FROM `{$wpdb->prefix}woocommerce_tax_rates` WHERE `tax_rate_class` = %s;", sanitize_title($cms_tax_class)));
        $cms_tax_id = json_decode(json_encode($cms_tax_id), true);

        $pechka_kkm_tax_table = $wpdb->get_blog_prefix() . 'pechka_kkm_tax';
        $taxes = $wpdb->get_results("SELECT * FROM {$pechka_kkm_tax_table}");
        $taxes_array = json_decode(json_encode($taxes), true);

        foreach ($taxes_array as $kkm_tax_item) {
            //Получаем массив cms_tax_id
            $cms_tax_id_list = explode(",", $kkm_tax_item['cmstaxid']);
            if (in_array($cms_tax_id["tax_rate_id"], $cms_tax_id_list)) {
                $current_kkm_tax_id = $kkm_tax_item['id'];
//                break;
            }
        }
        /*Если налоги в woocommerce не включены или соответсвие налоговой ставки для товара не найдено передаем 4 */
        if (!wc_tax_enabled() || (empty($current_kkm_tax_id))) {
            $current_kkm_tax_id = '4';
        }
        return (string)$current_kkm_tax_id;
    }

    /*Обновляем значения в соответсвии налогвых ставок из woocommerce и кассы*/
    function update_tax_value($cms_taxes_id_list, $kkm_tax_id_list, $taxes_table)
    {
        global $wpdb;
        $i = 0;

        foreach ($cms_taxes_id_list as $cms_tax_item) {

            if (isset($_POST[$cms_tax_item])) {

                $kkm_tax_id = implode(",", $_POST[$cms_tax_item]);
                $key = array_search($kkm_tax_id, $kkm_tax_id_list);

                if ($key !== false) {
                    unset($kkm_tax_id_list[$key]);
                    $i = 0;
                }

                if ($i != 0) {
                    $last_tax_id_item = json_decode(json_encode($wpdb->get_row("SELECT * FROM {$taxes_table} WHERE id = $kkm_tax_id")), true);
                    $last_tax_id_item = explode(",", $last_tax_id_item['cmstaxid']);

                    foreach ($last_tax_id_item as $item) {
                        $cms_tax_item .= ',' . $item;
                    }
                }

                $wpdb->update(
                    $taxes_table,
                    array('cmstaxid' => $cms_tax_item),
                    array('id' => $kkm_tax_id)
                );

                $i++;
            }
        }

        $del_tax_id = '';
        foreach ($kkm_tax_id_list as $tax_item) {
            $wpdb->update(
                $taxes_table,
                array('cmstaxid' => $del_tax_id),
                array('id' => $tax_item)
            );
        }
    }
